big fix switch-mail-host plus minor improvements
[distro-setup] / brc
1 #!/bin/bash
2 # Copyright (C) 2019 Ian Kelling
3 # SPDX-License-Identifier: AGPL-3.0-or-later
4 # this gets sourced. shebang is just for file mode detection
5
6 # Use source ~/.bashrc instead of doing bash -l when running a script
7 # so this can set extdebug and avoid the bash debugger.
8 if [[ -s /a/bin/errhandle/err ]]; then
9 source /a/bin/errhandle/err
10 elif [[ -s $bashrc_dir/err ]]; then
11 # shellcheck source=/a/bin/errhandle/err
12 source $bashrc_dir/err
13 fi
14
15 # In t8, it runs clear_console for login shells by default. I don't want
16 # my console cleared. And linux ttys get cleared without this.
17 if shopt login_shell >/dev/null && [[ -e ~/.bash_logout ]]; then
18 rm ~/.bash_logout
19 fi
20
21 # if [[ -s /usr/share/bash-completion/completions/git ]]; then
22 # source /usr/share/bash-completion/completions/git
23 # fi
24 # if [[ -s /usr/share/bash-completion/completions/gitk ]]; then
25 # source /usr/share/bash-completion/completions/gitk
26 # fi
27
28 # for testing error catching:
29 # t2() {
30 # echo t2
31 # grep sdf sdfd
32 # echo wtf
33 # }
34 # t1() {
35 # echo t1
36 # t2 a b c
37 # }
38
39 # * settings
40
41 CDPATH=.
42
43
44 # remove all aliases. aliases provided by the system tend to get in the way,
45 # for example, error happens if I try to define a function the same name as an alias
46 unalias -a
47
48 # remove gnome keyring warning messages
49 # there is probably a more proper way, but I didnt find any easily on google
50 # now using xfce+xmonad instead of vanilla xmonad, so disabling this
51 #unset GNOME_KEYRING_CONTROL
52
53 # use extra globing features.
54 shopt -s extglob
55 # include .files when globbing, but ignore files name . and ..
56 # setting this also sets dotglob.
57 export GLOBIGNORE="*/.:*/.."
58
59 # Useful info. see man bash.
60 PS4='$LINENO+ '
61
62
63 # broken with bash_completion package. Saw a bug for this once. dont anymore.
64 # still broken in wheezy
65 # still buggered in latest stable from the web, version 2.1
66 # perhaps its fixed in newer git version, which fails to make for me
67 # this note is from 6-2014.
68 # still broken in flidas.
69 #shopt -s nullglob
70
71 # make tab on an empty line do nothing
72 shopt -s no_empty_cmd_completion
73
74 # fix spelling errors for cd, only in interactive shell
75 shopt -s cdspell
76 # append history instead of overwritting it
77 shopt -s histappend
78 # for compatibility, per gentoo/debian bashrc
79 shopt -s checkwinsize
80 # attempt to save multiline single commands as single history entries.
81 shopt -s cmdhist
82 # enable **
83 shopt -s globstar
84
85
86 # inside emacs fixes
87 if [[ $LC_INSIDE_EMACS ]]; then
88 # EMACS is used by bash on startup, but we dont need it anymore.
89 # plus I hit a bug in a makefile which inherited it
90 unset EMACS
91 export LC_INSIDE_EMACS
92 export PAGER=cat
93 export MANPAGER=cat
94 # scp completion does not work, but this doesnt fix it. todo, figure this out
95 #complete -r scp &> /dev/null
96 # todo, remote file completion fails, figure out how to turn it off
97 export NODE_DISABLE_COLORS=1
98 # This gets rid of ugly terminal escape chars in node repl
99 # sometime, Id like to have completion working in emacs shell for node
100 # the offending chars can be found in lib/readline.js,
101 # things that do like:
102 # stream.write('\x1b[' + (x + 1) + 'G');
103 # We can remove them and keep readline, for example by doing this
104 # to start a repl:
105 #!/usr/bin/env nodejs
106 # var readline = require('readline');
107 # readline.cursorTo = function(a,b,c) {};
108 # readline.clearScreenDown = function(a) {};
109 # const repl = require('repl');
110 # var replServer = repl.start('');
111 #
112 # no prompt, or else readline complete seems to be confused, based
113 # on our column being different? node probably needs to send
114 # different kind of escape sequence that is not ugly. Anyways,
115 # completion doesnt work yet even with the ugly prompt, so whatever
116 #
117 export NODE_NO_READLINE=1
118
119 fi
120
121 export SSH_CONFIG_FILE_OVERRIDE=/root/.ssh/confighome
122
123 # emacs has a different default search path than the info command. This
124 # adds the info defaults to emacs, but not the reverse, because I dun
125 # care much about the cli. The search path is only on the cli if you run
126 # "info xxx", or in emacs if you run '(info xxx)', so not that
127 # important, but might as well fix it.
128
129 # info info says this path is what was compiled, and its not documented
130 # anywhere. Through source grepping, i found it in filesys.h of the info
131 # source in trisquel flidas.
132 #
133 # Traling : means for emacs to add its own stuff on to the end.
134
135 export INFOPATH=$PATH:/usr/local/info:/usr/info:/usr/local/lib/info:/usr/lib/info:/usr/local/gnu/info:/usr/local/gnu/lib/info:/usr/gnu/info:/usr/gnu/lib/info:/opt/gnu/info:/usr/share/info:/usr/share/lib/info:/usr/local/share/info:/usr/local/share/lib/info:/usr/gnu/lib/emacs/info:/usr/local/gnu/lib/emacs/info:/usr/local/lib/emacs/info:/usr/local/emacs/info:.:
136
137 # for openwrt system that has no stty, this is easier than
138 # guarding every time i use it.
139 if ! type -p stty >/dev/null; then
140 stty() { :; }
141 fi
142
143
144 use_color=false
145 if [[ $- == *i* ]]; then
146 # for readline-complete.el
147 if [[ $LC_INSIDE_EMACS ]]; then
148 # all for readline-complete.el
149 stty echo
150 bind 'set horizontal-scroll-mode on'
151 bind 'set print-completions-horizontally on'
152 bind '"\C-i": self-insert'
153 else
154
155
156 if [[ $TERM != dumb ]] && test -t 1; then
157 use_color=true
158 fi
159
160 if [[ $KONSOLE_PROFILE_NAME ]]; then
161 TERM=xterm-256color
162 fi
163
164 if [[ $TERM == alacritty && ! -e /usr/share/terminfo/a/alacritty ]]; then
165 # todo: we should try installing the alacritty terminfo if it is not found
166 # https://github.com/alacritty/alacritty/issues/2838
167 TERM=xterm-256color
168 fi
169
170 # copying from the alacritty example above,
171 if [[ $TERM == xterm-kitty ]]; then
172 if [[ ! -e /usr/share/terminfo/x/xterm-kitty ]]; then
173 TERM=xterm-256color
174 else
175 if [[ -e /a/opt/kitty/shell-integration/bash/kitty.bash ]]; then
176 KITTY_SHELL_INTEGRATION=t
177 source /a/opt/kitty/shell-integration/bash/kitty.bash
178 fi
179 fi
180 fi
181
182 # todo: not sure this works in sakura
183 #stty werase undef
184 #bind "\C-w": kill-region
185 # sakura == xterm-256color
186 # konsole == xterm
187 if [[ $TERM != xterm-kitty && $TERM == xterm* ]]; then
188 # control + arrow keys. for other terminals, see http://unix.stackexchange.com/questions/10806/how-to-change-previous-next-word-shortcut-in-bash
189 bind '"\e[1;5C": shell-forward-word' 2>/dev/null
190 bind '"\e[1;5D": shell-backward-word' 2>/dev/null
191 else
192 # make ctrl-backspace work. for konsole, i fixed it through
193 # /home/iank/.local/share/konsole/default.keytab
194 stty werase ^h
195 bind '"\eOc": shell-forward-word'
196 bind '"\eOd": shell-backward-word'
197 fi
198 # i cant remember why i did this, probably to free up some keys to bind
199 # to other things in bash.
200 # other than C-c and C-z, the rest defined by stty -a are, at least in
201 # gnome-terminal, overridden by bash, or disabled by the system
202 stty lnext undef stop undef start undef
203 fi
204
205 fi
206
207 case $TERM in
208 # fixup broken backspace in chroots
209 xterm-kitty|alacritty)
210 chroot() {
211 TERM=xterm-256color command chroot "$@"
212 }
213 ;;
214 esac
215
216 export BC_LINE_LENGTH=0
217
218 # ansible option
219 export PROFILE_TASKS_TASK_OUTPUT_LIMIT=100
220
221 # note, if I use a machine I dont want files readable by all users, set
222 # umask 077 # If fewer than 4 digits are entered, leading zeros are assumed
223
224 # i for insensitive. the rest from
225 # X means dont remove the current screenworth of output upon exit
226 # R means to show colors n things
227 # a useful flag is -F aka --quit-if-one-screen
228 export LESS=RXij12
229 export SYSTEMD_LESS=$LESS
230
231 export NNN_COLORS=2136
232
233 export SL_FILES_DIR=/b/ds/sl/.iank
234 export SL_INFO_DIR=/p/sshinfo
235
236
237 # * include files
238
239 if [[ -s $bashrc_dir/path-add-function ]]; then
240 source $bashrc_dir/path-add-function
241 if [[ $SSH_CLIENT ]]; then
242 if grep -qF /home/iank/.iank/e/e /etc/exports &>/dev/null; then
243 export EMACSDIR=/home/iank/.iank/e/e
244 fi
245 path-add $bashrc_dir
246 fi
247 fi
248
249 # if someone exported $SOE (stop on error), catch errors.
250 #
251 # Note, on debian this results in the following warning when in ssh,
252 # hich I haven't figured out how to fix. It doesn't happen if we source
253 # after the shell has started
254 #
255 # bash: /usr/share/bashdb/bashdb-main.inc: No such file or directory
256 # bash: warning: cannot start debugger; debugging mode disabled
257 if [[ $SOE ]]; then
258 if [[ -e /a/bin/errhandle/err ]]; then
259 source /a/bin/errhandle/err
260 fi
261 fi
262
263
264
265
266 mysrc() {
267 local path dir file
268 path=$1
269 dir=${path%/*}
270 file=${path##*/}
271 if [[ -s $path ]]; then
272 source $path
273 elif [[ -s $bashrc_dir/$file ]]; then
274 source $bashrc_dir/$file
275 fi
276 }
277
278
279 mysrc /a/bin/small-misc-bash/ll-function
280 mysrc /a/bin/distro-functions/src/package-manager-abstractions
281
282 # things to remember:
283 # ALT-C - cd into the selected directory
284 # CTRL-T - Paste the selected file path into the command line
285 #
286 # good guide to some of its basic features is the readme file
287 # https://github.com/junegunn/fzf
288
289 # if [[ -s /usr/share/doc/fzf/examples/key-bindings.bash ]]; then
290 # source /usr/share/doc/fzf/examples/key-bindings.bash
291 # fi
292
293 # * functions
294
295 ### begin FSF section ###
296
297 # Comments before functions are meant to be good useful
298 # documentation. If they fail at that, please improve them or send Ian a
299 # note.
300
301 ## copy bash completion
302 # Usage: ORIGINAL_COMMAND TARGET_COMMAND...
303 #
304 # It copies how the bash completion works from one command to other
305 # commands.
306 ccomp() {
307 local c src
308 src=$1
309 shift
310 if ! c=$(complete -p $src 2>/dev/null); then
311 _completion_loader $src &>/dev/null ||:
312 c=$(complete -p $src 2>/dev/null) || return 0
313 fi
314 # remove $src( .*|$)
315 c=${c% $src}
316 c=${c%% $src *}
317 eval $c $*
318 }
319
320 ## directory history tracking and navigation.
321 #
322 # cd becomes a function, also aliased to c. b to go back, f to go
323 # forward, cl to list recent directories and choose one.
324 #
325 # The finer details you may want to skip:
326 #
327 # We also define bl to print the list of back and forward directories.
328 #
329 # We keep 2 stacks, forward and back. Unlike with a web browser, the
330 # forward stack is not erased when going somewhere new.
331 #
332 # Recent directories are stored in ~/.cdirs.
333 #
334 declare -a _dir_forward _dir_back
335 c() {
336 # normally, the top of _dir_back is our current dir. if it isn't,
337 # put it on there, except we don't want to do that when we
338 # just launched a shell
339 if [[ $OLDPWD ]]; then
340 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
341 _dir_back+=("$PWD")
342 fi
343 fi
344 command cd "$@"
345 if (( ${#_dir_back[@]} == 0 )) || [[ ${_dir_back[-1]} != "$PWD" ]]; then
346 _dir_back+=("$PWD")
347 fi
348 echo "$PWD" >> ~/.cdirs
349 }
350 ccomp cd c
351
352 # back
353 b() {
354 local top_back
355 if (( ${#_dir_back[@]} == 0 )); then
356 echo "nothing left to go back to" >&2
357 return 0
358 fi
359 top_back="${_dir_back[-1]}"
360
361 if [[ $top_back == "$PWD" ]] && (( ${#_dir_back[@]} == 1 )); then
362 echo "already on last back entry" >&2
363 return 0
364 fi
365
366
367 if [[ $top_back == "$PWD" ]]; then
368 # add to dirf if not already there
369 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$top_back" ]]; then
370 _dir_forward+=("$top_back")
371 fi
372 unset "_dir_back[-1]"
373 command cd "${_dir_back[-1]}"
374 else
375 if (( ${#_dir_forward[@]} == 0 )) || [[ ${_dir_forward[-1]} != "$PWD" ]]; then
376 _dir_forward+=("$PWD")
377 fi
378 command cd "$top_back"
379 fi
380
381 # Interesting feature, not sure I want it.
382 # give us a peek at what is next in the list
383 # if (( ${#_dir_back[@]} >= 2 )); then
384 # printf "%s\n" "${_dir_back[-2]}"
385 # fi
386 #
387
388 # c/b/f Implementation notes:
389 #
390 # The top of the back is $PWD
391 # as long as the last directory change was due to c,b,or cl.
392 #
393 # Example of stack changes:
394 #
395 # a b c (d)
396 ## back
397 # a b (c)
398 # d
399 #back
400 #a (b)
401 #d c
402 #back
403 #(a)
404 #d c b
405 #forward
406 #a (b)
407 #d c
408 #
409 # a b c
410 ## back
411 # a b
412 # (c)
413 ## forward
414
415 }
416 # forward
417 f() {
418 local top_forward
419 if (( ${#_dir_forward[@]} == 0 )); then
420 echo "no forward dir left" >&2
421 return 0
422 fi
423 top_forward="${_dir_forward[-1]}"
424 unset "_dir_forward[-1]"
425 c "$top_forward"
426
427 # give us a peek at what is next in the list
428 # if (( ${#_dir_forward[@]} )); then
429 # printf "%s\n" "${_dir_forward[-1]}"
430 # fi
431 }
432 # cd list
433 cl() {
434 local i line input start
435 local -A buttondirs alines
436 local -a buttons dirs lines
437 buttons=( {a..z} {2..9} )
438 if [[ ! -s ~/.cdirs ]]; then
439 echo nothing in ~/.cdirs
440 return 0
441 fi
442
443 i=0
444
445 mapfile -t lines <~/.cdirs
446 start=$(( ${#lines[@]} - 1 ))
447
448 # we have ~33 buttons as of this writing, so lets
449 # prune down the history every once in a while.
450 if (( start > 500 )); then
451 tac ~/.cdirs | awk '!seen[$0]++' | head -n 200 | tac | sponge ~/.cdirs || [[ $? == 141 ]]
452 fi
453
454 for (( j=$start; j >= 0; j-- )); do
455 line="${lines[$j]}"
456 if [[ ! $line || ${alines[$line]} || ! -d "$line" || $line == "$PWD" || line == "$HOME" ]]; then
457 continue
458 fi
459 alines[$line]=t
460 buttondirs[${buttons[i]}]="$line"
461 printf "%s %s\n" ${buttons[i]} "$line"
462 if (( i == ${#buttons[@]} - 1 )); then
463 break
464 fi
465 i=$(( i + 1 ))
466 done
467
468 if (( i == 0 )); then
469 echo "no dirs in ~/.cdirs"
470 return 0
471 fi
472 read -r -N 1 input
473 if [[ $input != $'\n' ]]; then
474 c "${buttondirs[$input]}"
475 fi
476 }
477 # back list
478 bl() {
479 local start i j max
480 max=10
481 start=$(( ${#_dir_back[@]} - 1 ))
482
483 # cleanup possible repeating of pwd
484 if (( start >= 0 )) && [[ ${_dir_back[$start]} == "$PWD" ]]; then
485 start=$(( start - 1 ))
486 fi
487 j=1
488 if (( start >= 0 )); then
489 for (( i=$start; i >= 0 ; i-- )); do
490 printf "%s %s\n" $j ${_dir_back[i]}
491 j=$(( j + 1 ))
492 if (( j >= max )); then
493 break
494 fi
495 done
496 fi
497
498 max=10
499 start=$(( ${#_dir_forward[@]} - 1 ))
500
501 # cleanup possible repeating of pwd
502 if (( start >= 0 )) && [[ ${_dir_forward[$start]} == "$PWD" ]]; then
503 start=$(( start - 1 ))
504 fi
505 if (( start < 0 )); then
506 return 0
507 fi
508 echo --
509 j=1
510 for (( i=$start; i >= 0 ; i-- )); do
511 printf "%s %s\n" $j ${_dir_forward[i]}
512 j=$(( j + 1 ))
513 if (( j >= max )); then
514 break
515 fi
516 done
517 }
518
519 # pee do. run args as a command with output copied to syslog.
520 #
521 # Usage: pd [-t TAG] COMMAND...
522 #
523 # -t TAG Override the tag in the syslog. The default is COMMAND with
524 # any path part is removed, eg. for /bin/cat the tag is cat.
525 #
526 # You can view the log via "journalctl -t TAG"
527 pd() {
528 local tag ret
529 ret=0
530 tag=${1##*/}
531 case $1 in
532 -t) tag="$2"; shift 2 ;;
533 esac
534 echo "PWD=$PWD command: $*" | logger -t $tag
535 "$@" |& pee cat "logger -t $tag" || ret=$?
536 echo "exited with status=$ret" | pee cat "logger -t $tag"
537 # this avoids any err-catch
538 (( $ret == 0 )) || return $ret
539 }
540 ccomp time pd
541
542 # jdo = journal do. Run command as transient systemd service, tailing
543 # its output in the journal until it completes.
544 #
545 # Usage: jdo COMMAND...
546 #
547 # Compared to pd: commands recognize this is a non-interactive shell.
548 # The service is unaffected if our ssh connection dies, no need to run
549 # in screen or tmux.
550 #
551 # Note: The last few lines of any existing entries for a unit by that
552 # name will be output first, and there will be a few second delay at the
553 # start of the command, and a second or so at the end.
554 #
555 # Note: Functions and aliases obviously won't work, we resolve the
556 # command to a file.
557 #
558 # Note: requires running as root.
559 jdo() {
560 local cmd cmd_name jr_pid ret
561 ret=0
562 cmd="$1"
563 shift
564 if [[ $EUID != 0 ]]; then
565 echo "jdo: error: rerun as root"
566 return 1
567 fi
568 cmd_name=${cmd##*/}
569 if [[ $cmd != /* ]]; then
570 cmd=$(type -P "$cmd")
571 fi
572 # -q = quiet
573 journalctl -qn2 -f -u "$cmd_name" &
574 # Trial and error of time needed to avoid missing initial lines.
575 # .5 was not reliable. 1 was not reliable. 2 was not reliable
576 sleep 4
577 jr_pid=$!
578 systemd-run --unit "$cmd_name" --wait --collect "$cmd" "$@" || ret=$?
579 # The sleep lets the journal output its last line
580 # before the prompt comes up.
581 sleep .5
582 kill $jr_pid &>/dev/null ||:
583 unset jr_pid
584 fg &>/dev/null ||:
585 # this avoids any err-catch
586 (( $ret == 0 )) || return $ret
587 }
588 ccomp time jdo
589 #### end fsf section
590
591
592 ..() { c ..; }
593 ...() { c ../..; }
594 ....() { c ../../..; }
595 .....() { c ../../../..; }
596 ......() { c ../../../../..; }
597
598 chere() {
599 local f path
600 for f; do
601 path=$(readlink -e "$f")
602 echo "cat >$path <<'EOF'"
603 cat "$f"
604 echo EOF
605 done
606 }
607
608
609 # file cut copy and paste, like the text buffers :)
610 # I havnt tested these.
611 _fbufferinit() { # internal use
612 ! [[ $my_f_tempdir ]] && my_f_tempdir=$(mktemp -d)
613 rm -rf "${my_f_tempdir:?}"/*
614 }
615 fcp() { # file cp
616 _fbufferinit
617 cp "$@" "$my_f_tempdir"/
618 }
619 fct() { # file cut
620 _fbufferinit
621 mv "$@" "$my_f_tempdir"/
622 }
623 fpst() { # file paste
624 [[ $2 ]] && { echo too many arguments; return 1; }
625 target=${1:-.}
626 cp "$my_f_tempdir"/* "$target"
627 }
628
629 _khfix_common() {
630 local host ip port file key
631 read -r host ip port < <(timeout -s 9 2 ssh -oBatchMode=yes -oControlMaster=no -oControlPath=/ -v $1 |& sed -rn "s/debug1: Connecting to ([^ ]+) \[([^\]*)] port ([0-9]+).*/\1 \2 \3/p" ||: )
632 file=$(readlink -f ~/.ssh/known_hosts)
633 if [[ ! $ip ]]; then
634 echo "khfix: ssh failed"
635 return 1
636 fi
637 if [[ $port != 22 ]]; then
638 ip_entry="[$ip]:$port"
639 host_entry="[$host]:$port"
640 else
641 ip_entry=$ip
642 host_entry=$host
643 fi
644 tmpfile=$(mktemp)
645 if [[ $host != $ip ]]; then
646 key=$(ssh-keygen -F "$host_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
647 if [[ $key ]]; then
648 grep -Fv "$key" "$file" | sponge "$file"
649 fi
650 fi
651 key=$(ssh-keygen -F "$ip_entry" -f $file | sed -r 's/^.*([^ ]+ +[^ ]+) *$/\1/')
652 if [[ $key ]]; then
653 grep -Fv "$key" "$file" | sponge "$file"
654 fi
655 ll ~/.ssh/known_hosts
656 rootsshsync
657 }
658 khfix() { # known hosts fix
659 _khfix_common "$@" || return 1
660 ssh $1 :
661 }
662 khcopy() {
663 _khfix_common "$@"
664 ssh-copy-id $1
665 }
666
667 # ya, hacky hardcoded hostnames in 2023. we could do better
668 hssh-update() {
669 local -a failed_hosts
670 for host in kd x3.office.fsf.org syw; do
671 e $host
672 if ! scp /b/fai/fai/config/files/usr/local/bin/hssh/IANK root@$host:/usr/local/bin/hssh; then
673 failed_hosts+=($host)
674 fi
675 done
676 if (( ${#failed_hosts[@]} >= 1 )); then
677 echo failed_hosts=${failed_hosts[*]}
678 return 1
679 fi
680 }
681
682 a() {
683 local x
684 x=$(readlink -nf "${1:-$PWD}")
685 # yes, its kinda dumb that xclip/xsel cant do this in one invocation
686 echo -n "$x" | xclip -selection clipboard
687 echo -n "$x" | xclip
688 }
689
690 # a1 = awk {print $1}
691 for field in {1..20}; do
692 eval a$field"() { awk '{print \$$field}'; }"
693 done
694 # h1 = head -n1
695 for num in {1..9}; do
696 eval h$num"() { head -n$num; }"
697 done
698
699
700 hexipv4() {
701 printf '%d.%d.%d.%d\n' $(echo $1 | sed 's/../0x& /g')
702 }
703
704 vp9() {
705 local f out outdir in fname origdir skip1
706 origdir="$PWD"
707 outdir=vp9
708 skip1=false
709 while [[ $1 == -* ]]; do
710 case $1 in
711 # if we got interrupted after 1st phase
712 -2)
713 skip1=true
714 shift
715 ;;
716 --out)
717 outdir=$2
718 shift 2
719 ;;
720 esac
721 done
722 m mkdir -p $outdir
723 # first pass only uses about 1 cpu, so run in parallel
724 for f; do
725 {
726 fname="${f##*/f}"
727 if [[ $f == /* ]]; then
728 in="$f"
729 else
730 in=$origdir/$f
731 fi
732 out="$origdir/$outdir/$fname"
733 mkdir -p /tmp/vp9/$fname
734 cd /tmp/vp9/$fname
735 if ! $skip1 && [[ ! -s ffmpeg2pass-0.log ]]; then
736 # -nostdin or else wait causes ffmpeg to go into stopped state. dunno why, random stackoverflow answer.
737 m ffmpeg -nostdin -hide_banner -loglevel error -i $in -g 192 -vcodec libvpx-vp9 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 1 -an -f null /dev/null
738 fi
739 if [[ -e $out ]]; then rm -f $out; fi
740 m ffmpeg -nostdin -hide_banner -loglevel error -y -i $in -g 192 -vcodec libvpx-vp9 -tile-rows 2 -vf scale=-1:720 -max_muxing_queue_size 9999 -b:v 750K -pass 2 -c:a libvorbis -qscale:a 5 $out
741 } &
742 done
743 wait -f
744 cd "$origdir"
745 }
746
747 utcl() { # utc 24 hour time to local hour 24 hour time
748 echo "print( ($1 $(date +%z | sed -r 's/..$//;s/^(-?)0*/\1/')) % 24)"|python3
749 }
750
751 bwm() {
752 s bwm-ng -T avg -d
753 }
754
755
756 # for running in a fai rescue. iank specific.
757 kdrescue() {
758 d=vgata-Samsung_SSD_850_EVO_2TB_S2RLNX0J502123D
759 for f in $d vgata-Samsung_SSD_870_QVO_8TB_S5VUNG0N900656V; do
760 cryptsetup luksOpen --key-file /p /dev/$f/root crypt-$f-root
761 cryptsetup luksOpen --key-file /p /dev/$f/o crypt-$f-o
762 done
763 mount -o subvol=root_trisquelaramo /dev/mapper/crypt-$d-root /mnt
764 mount -o subvol=a /dev/mapper/crypt-$d-root /mnt/a
765 mount -o subvol=o /dev/mapper/crypt-$d-o /mnt/o
766 mount -o subvol=boot_trisquelaramo /dev/sda2 /mnt/boot
767 cd /mnt
768 chrbind
769 }
770
771
772
773
774 c4() { c /var/log/exim4; }
775
776 caa() { git commit --amend --no-edit -a; }
777
778 cf() {
779 for f; do
780 hr
781 echo "$f"
782 hr
783 cat "$f"
784 done
785 }
786 caf() {
787 # shellcheck disable=SC2033
788 find -L "$@" -type f -not \( -name .svn -prune -o -name .git -prune \
789 -o -name .hg -prune -o -name .editor-backups -prune \
790 -o -name .undo-tree-history -prune \) \
791 -exec bash -c '. ~/.bashrc; hr; echo "$1"; hr; cat "$1"' _ {} \; 2>/dev/null
792
793 }
794 ccomp cat cf caf
795
796 calc() { echo "scale=3; $*" | bc -l; }
797 # no having to type quotes, but also no command history:
798 clc() {
799 local x
800 read -r x
801 echo "scale=3; $x" | bc -l
802 }
803
804 cam() {
805 git commit -am "$*"
806 }
807
808 ccat () { # config cat. see a config without extra lines.
809 sed -r '/^[[:space:]]*([;#]|--|\/\/|$)/d' "$@"
810 }
811 ccomp grep ccat
812
813 chrbind() {
814 local d
815 # dev/pts needed for pacman signature check
816 for d in dev proc sys dev/pts; do
817 [[ -d $d ]]
818 if ! mountpoint $d &>/dev/null; then
819 m s mount -o bind /$d $d
820 fi
821 done
822 }
823 chumount() {
824 local d
825 # dev/pts needed for pacman signature check
826 for d in dev/pts dev proc sys; do
827 [[ -d $d ]]
828 if mountpoint $d &>/dev/null; then
829 m s umount $d
830 fi
831 done
832 }
833
834
835 _cdiff-prep() {
836 # join options which are continued to multiples lines onto one line
837 local first=true
838 while IFS= read -r line; do
839 # remove leading spaces/tabs. assumes extglob
840 if [[ $line == "[ ]*" ]]; then
841 line="${line##+( )}"
842 fi
843 if $first; then
844 pastline="$line"
845 first=false
846 elif [[ $line == *=* ]]; then
847 echo "$pastline" >> "$2"
848 pastline="$line"
849 else
850 pastline="$pastline $line"
851 fi
852 done < <(grep -vE '^([ \t]*#|^[ \t]*$)' "$1")
853 echo "$pastline" >> "$2"
854 }
855
856 cdiff() {
857 # diff config files,
858 # setup for format of postfix, eg:
859 # option = stuff[,]
860 # [more stuff]
861 local pastline unified f1 f2
862 unified="$(mktemp)"
863 f1="$(mktemp)"
864 f2="$(mktemp)"
865 _cdiff-prep "$1" "$f1"
866 _cdiff-prep "$2" "$f2"
867 cat "$f1" "$f2" | grep -Po '^[^=]+=' | sort | uniq > "$unified"
868 while IFS= read -r line; do
869 # the default bright red / blue doesnt work in emacs shell
870 dwdiff -cblue,red -A best -d " ," <(grep "^$line" "$f1" || echo ) <(grep "^$line" "$f2" || echo ) | colordiff
871 done < "$unified"
872 }
873
874
875 cat-new-files() {
876 local start=$SECONDS
877 local dir="$1"
878 # shellcheck disable=SC2030
879 inotifywait -m "$dir" -e create -e moved_to | \
880 while read -r filedir _ file; do
881 cat "$filedir$file"
882 hr
883 calc $((SECONDS - start)) / 60
884 sleep 5
885 done
886
887 }
888
889 chownme() {
890 s chown -R $USER:$USER "$@"
891 }
892
893 # shellcheck disable=SC2032
894 chown() {
895 # makes it so chown -R symlink affects the symlink and its target.
896 if [[ $1 == -R ]]; then
897 shift
898 command chown -h "$@"
899 command chown -R "$@"
900 else
901 command chown "$@"
902 fi
903 }
904
905 cim() {
906 git commit -m "$*"
907 }
908
909
910 d() { builtin bg "$@"; }
911 ccomp bg d
912
913 # f would be more natural, but i already am using it for something
914 z() { builtin fg "$@"; }
915 ccomp fg z
916
917 x() { builtin kill %%; }
918
919 dc() {
920 diff --strip-trailing-cr -w "$@" # diff content
921 }
922 ccomp diff dc
923
924 despace() {
925 local x y
926 for x in "$@"; do
927 y="${x// /_}"
928 safe_rename "$x" "$y"
929 done
930 }
931
932 # df progress
933 # usage: dfp MOUNTPOINT [SECOND_INTERVAL]
934 # SECOND_INTERVAL defaults to 90
935 dfp() {
936 # mp = mountpoint
937 local a b mp interval
938 mp=$1
939 interval=${2:-90}
940 if [[ ! $mp ]]; then
941 echo "dfp: error, missing 1st arg" >&2
942 return 1
943 fi
944 while true; do
945 a=$(df --output=used $mp | tail -n1)
946 sleep $interval
947 b=$(df --output=used $mp | tail -n1)
948 printf "used mib: %'d mib/min: %s\n" $(( b /1000 )) $(( (b-a) / (interval * 1000 / 60 ) ))
949 done
950 }
951
952 # get ipv4 ip from HOST. or if it is already a number, return that
953 hostip() {
954 local host="$1"
955 case $host in
956 [0-9:])
957 echo "$host"
958 ;;
959 *)
960 getent ahostsv4 "$host" | awk '{ print $1 }' | head -n1
961 ;;
962 esac
963 }
964
965 dig() {
966 command dig +nostats +nocmd "$@"
967 }
968 # Output with sections sorted, and removal of query id, so 2 dig outputs can be diffed.
969 digsort() {
970 local sec
971 sec=
972 dig +nordflag "$@" | sed -r 's/^(;; ->>HEADER<<-.*), id: .*/\1/' | while read -r l; do
973 if [[ $l == [^\;]* ]]; then
974 sec+="$l"$'\n'
975 else
976 if [[ $sec ]]; then
977 printf "%s" "$sec" | sort
978 sec=
979 fi
980 printf "%s\n" "$l"
981 fi
982 done
983 }
984 ccomp dig digsort
985 # compare digs to the 2 servers
986 # usage: digdiff @server1 @server2 DIG_ARGS
987 # note: only the soa master nameserver will respond with
988 # ra "recursive answer" flag. That difference is meaningless afaik.
989 digdiff() {
990 local s1 s2
991 s1=$1
992 shift
993 s2=$1
994 shift
995 digsort $s1 "$@" | tee /tmp/digdiff
996 diff -u /tmp/digdiff <(digsort $s2 "$@")
997 }
998
999 # date in a format i like reading
1000 dt() {
1001 date "+%A, %B %d, %r" "$@"
1002 }
1003 dtr() {
1004 date -R "$@"
1005 }
1006 # date with all digits in a format i like
1007 dtd() {
1008 date +%F_%T% "$@"
1009 }
1010 ccomp date dt dtr dtd
1011
1012 dus() { # du, sorted, default arg of
1013 du -sh ${@:-*} | sort -h
1014 }
1015 ccomp du dus
1016
1017
1018 e() { printf "%s\n" "$*"; }
1019
1020 # echo args
1021 ea() {
1022 if (( ! $# )); then
1023 echo no args
1024 fi
1025 for arg; do
1026 printf "%qEOL\n" "${arg}"
1027 printf "%s" "${arg}" |& hexdump -C
1028 done
1029 }
1030
1031 # echo variables. print var including escapes, etc, like xxd for variable
1032 ev() {
1033 if (( ! $# )); then
1034 echo no args
1035 fi
1036 for arg; do
1037 if [[ -v $arg ]]; then
1038 printf "%qEOL\n" "${!arg}"
1039 printf "%s" "${!arg}" |& hexdump -C
1040 else
1041 echo arg $arg is unset
1042 fi
1043 done
1044 }
1045
1046 ediff() {
1047 [[ ${#@} == 2 ]] || { echo "error: ediff requires 2 arguments"; return 1; }
1048 emacs --eval "(ediff-files \"$1\" \"$2\")"
1049 }
1050
1051 # mail related
1052 etail() {
1053 ngset
1054 tail -F /var/log/exim4/mainlog /var/log/exim4/*main /var/log/exim4/paniclog /var/log/exim4/*panic -n 200 "$@"
1055 ngreset
1056 }
1057 etailm() {
1058 tail -F /var/log/exim4/mainlog -n 200 "$@"
1059 }
1060 etail2() {
1061 tail -F /var/log/exim4/mymain -n 200 "$@"
1062 }
1063 ccomp tail etail etail2
1064
1065 # ran into this online, trying it out
1066 detach() {
1067 ( "$@" &>/dev/null & disown )
1068 }
1069
1070 showkeys() {
1071 ssh "$@" cat .ssh/authorized_keys{,2}
1072 }
1073
1074
1075 # print exim old pids
1076 eoldpids() {
1077 local configtime pid piduptime now daemonpid
1078 printf -v now '%(%s)T' -1
1079 configtime=$(stat -c%Y /var/lib/exim4/config.autogenerated)
1080 if [[ -s /run/exim4/exim.pid ]]; then
1081 daemonpid=$(cat /run/exim4/exim.pid)
1082 fi
1083 for pid in $(pgrep -f '^/usr/sbin/exim4( |$)'); do
1084 # the daemonpid gets reexeced on HUP (service reloads), keeping its same old timestamp
1085 if [[ $pid == $daemonpid ]]; then
1086 continue
1087 fi
1088 piduptime=$(awk -v ticks="$(getconf CLK_TCK)" 'NR==1 { now=$1; next } END { printf "%9.0f\n", now - ($20/ticks) }' /proc/uptime RS=')' /proc/$pid/stat) ||: # sometimes pids disappear pretty fast
1089 if (( configtime > now - piduptime )); then
1090 echo $pid
1091 fi
1092 done
1093 }
1094
1095 # exim tail but only watch lines from new pids
1096 etailnew() {
1097 local pid oldpids
1098 for pid in $(eoldpids); do
1099 oldpids+="$pid|"
1100 done
1101 if [[ $oldpids ]]; then
1102 etail | awk '$3 !~ /^\[('"${oldpids%|}"')\]$/'
1103 else
1104 etail
1105 fi
1106 }
1107 # exim watch as old pids go away
1108 ewatchold() {
1109 local configtime pid piduptime now
1110 local -i count
1111 local -a oldpids
1112 count=0
1113 while true; do
1114 oldpids=($(eoldpids))
1115 if (( ! ${#oldpids[@]} )); then
1116 return
1117 fi
1118 # print the date every 20 iterations
1119 if (( ! count % 20 )); then
1120 date
1121 fi
1122 count+=1
1123 ps -f -p "${oldpids[*]}"
1124 sleep 1
1125 done
1126 }
1127
1128 eless() {
1129 less /var/log/exim4/mainlog
1130 }
1131 ccomp less eless
1132 eqcat() {
1133 exiqgrep -ir.\* -o 60 | while read -r i; do
1134 hlm exim -Mvc $i
1135 echo
1136 hlm exigrep $i /var/log/exim4/mainlog | cat ||:
1137 done
1138 }
1139 eqrmf() {
1140 # other ways to get the list of message ids:
1141 # exim -bp | awk 'NF == 4 {print $3}'
1142 # # this is slower 160ms, vs 60.
1143 # exipick -i
1144 exiqgrep -ir.\* | xargs exim -Mrm
1145 }
1146
1147 econfdevnew() {
1148 rm -rf /tmp/edev
1149 mkdir -p /tmp/edev/etc
1150 cp -ra /etc/exim4 /tmp/edev/etc
1151 cp -ra /etc/alias* /tmp/edev/etc
1152 find /tmp/edev/etc/exim4 -type f -execdir sed -i "s,/etc/,/tmp/edev/etc/,g" '{}' +
1153 econfdev
1154 }
1155 econfdev() {
1156 update-exim4.conf -d /tmp/edev/etc/exim4 -o /tmp/edev/e.conf
1157 }
1158
1159 # exim grep in
1160 # show important information about incoming mail in the exim log
1161 egrin() {
1162 sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).*T="(.*)" from (<[^ ]+> .*$)/\1 \4\n \3/p' <${1:-/var/log/exim4/mainlog}
1163 }
1164
1165 # 2nd line is message-id:
1166 egrinid() {
1167 sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).* id=([^ ]+) T="(.*)" from (<[^ ]+> .*$)/\1 \5\n \3\n \4/p' <${1:-/var/log/exim4/mainlog}
1168 }
1169 etailin() {
1170 tail -F /var/log/exim4/mainlog | sed -rn '/testignore|jtuttle|eximbackup/!s/^[^ ]+ ([^ ]+) [^ ]+ [^ ]+ <= ([^ ]+).*T="(.*)" from (<[^ ]+> .*$)/\1 \4\n \3/p'
1171 }
1172
1173
1174
1175
1176 fa() {
1177 # find array. make an array of file names found by find into $x
1178 # argument: find arguments
1179 # return: find results in an array $x
1180 while read -rd ''; do
1181 x+=("$REPLY");
1182 done < <(find "$@" -print0);
1183 }
1184
1185 faf() { # find all files. use -L to follow symlinks
1186 find "$@" -not \( -name .svn -prune -o -name .git -prune \
1187 -o -name .hg -prune -o -name .editor-backups -prune \
1188 -o -name .undo-tree-history -prune \) -type f 2>/dev/null
1189 }
1190
1191 # usage ffconcat FILES_TO_CONCAT OUTPUT_FILE
1192 ffconcat() {
1193 local tmpf
1194 tmpf=$(mktemp)
1195 printf "file '%s'\n" "$1" >$tmpf
1196 while (( $# > 1 )); do
1197 shift
1198 printf "file '%s'\n" "$1" >>$tmpf
1199 done
1200 # https://trac.ffmpeg.org/wiki/Concatenate
1201 ffmpeg -f concat -safe 0 -i $tmpf -c copy "$1"
1202 rm $tmpf
1203 }
1204 ffremux() {
1205 local tmpf tmpd
1206 if (( $# == 0 )); then
1207 echo ffremux error expected args >&2
1208 return 1
1209 fi
1210 tmpd=$(mktemp -d)
1211 for f; do
1212 tmpf=$tmpd/"${f##*/}"
1213 ffmpeg -i "$f" -c:v copy -c:a copy $tmpf
1214 cat $tmpf >"$f"
1215 done
1216 rm -r $tmpd
1217 }
1218
1219
1220
1221 # absolute path of file/dir without resolving symlinks.
1222 #
1223 # Most of the time, I want this where I would normally use readlink.
1224 # This is what realpath -s does in most cases, but sometimes it
1225 # actually resolves symlinks, at least when they are in /.
1226 #
1227 # Note, if run on a dir, if the final component is relative, it won't
1228 # resolve that. Use the below fpd for that.
1229 #
1230 # note: we could make a variation of this which
1231 # assigns to a variable name using eval, so that we don't have to do
1232 # x=$(fp somepath), which might save subshell overhead and look nice,
1233 # but I'm not going to bother.
1234 fp() {
1235 local initial_oldpwd initial_pwd dir base
1236 initial_oldpwd="$OLDPWD"
1237 initial_pwd="$PWD"
1238 if [[ $1 == */* ]]; then
1239 dir="${1%/*}"
1240 base="/${1##*/}"
1241 # CDPATH because having it set will cause cd to possibly print output
1242 CDPATH= cd "$dir"
1243 printf "%s%s\n" "$PWD" "$base"
1244 CDPATH= cd "$initial_pwd"
1245 OLDPWD="$initial_oldpwd"
1246 else
1247 printf "%s/%s\n" "$PWD" "$1"
1248 fi
1249 }
1250 # full path of directory without resolving symlinks
1251 fpd() {
1252 local initial_oldpwd initial_pwd dir
1253 initial_oldpwd="$OLDPWD"
1254 initial_pwd="$PWD"
1255 dir="$1"
1256 CDPATH= cd "$dir"
1257 printf "%s%s\n" "$PWD" "$base"
1258 cd "$initial_pwd"
1259 OLDPWD="$initial_oldpwd"
1260 }
1261
1262
1263 # mail related
1264 frozen() {
1265 rm -rf /tmp/frozen
1266 sudo mailq |gr frozen|awk '{print $3}' | while read -r id; do
1267 sudo exim -Mvl $id
1268 echo
1269 sudo exim -Mvh $id
1270 echo
1271 sudo exim -Mvb $id
1272 echo -e '\n\n##############################\n'
1273 done | tee -a /tmp/frozen
1274 }
1275 frozenrm() {
1276 local ids=()
1277 while read -r line; do
1278 printf '%s\n' "$line"
1279 ids+=($(printf '%s\n' "$line" |gr frozen|awk '{print $3}'))
1280 done < <(s mailq)
1281 echo "sleeping for 2 in case you change your mind"
1282 sleep 2
1283 sudo exim -Mrm "${ids[@]}"
1284 }
1285
1286 funce() {
1287 # like -e for functions. returns on error.
1288 # at the end of the function, disable with:
1289 # trap ERR
1290 trap 'echo "${BASH_COMMAND:+BASH_COMMAND=\"$BASH_COMMAND\" }
1291 ${FUNCNAME:+FUNCNAME=\"$FUNCNAME\" }${LINENO:+LINENO=\"$LINENO\" }\$?=$?"
1292 trap ERR
1293 return' ERR
1294 }
1295
1296 getdir () {
1297 local help="Usage: getdir [--help] PATH
1298 Output the directory of PATH, or just PATH if it is a directory."
1299 if [[ $1 == --help ]]; then
1300 echo "$help"
1301 return 0
1302 fi
1303 if [[ $# -ne 1 ]]; then
1304 echo "getdir error: expected 1 argument, got $#"
1305 return 1
1306 fi
1307 if [[ -d $1 ]]; then
1308 echo "$1"
1309 else
1310 local dir
1311 dir="$(dirname "$1")"
1312 if [[ -d $dir ]]; then
1313 echo "$dir"
1314 else
1315 echo "getdir error: directory does not exist"
1316 return 1
1317 fi
1318 fi
1319 }
1320
1321 git_empty_branch() { # start an empty git branch. carefull, it deletes untracked files.
1322 [[ $# == 1 ]] || { echo 'need a branch name!'; return 1;}
1323 local root
1324 root=$(gitroot) || return 1 # function to set gitroot
1325 builtin cd "$root"
1326 git symbolic-ref HEAD refs/heads/$1
1327 rm .git/index
1328 git clean -fdx
1329 }
1330
1331 # shellcheck disable=SC2120
1332 gitroot() {
1333 local help="Usage: gitroot [--help]
1334 Print the full path to the root of the current git repo
1335
1336 Handles being within a .git directory, unlike git rev-parse --show-toplevel,
1337 and works in older versions of git which did not have that."
1338 if [[ $1 == --help ]]; then
1339 echo "$help"
1340 return
1341 fi
1342 local p
1343 p=$(git rev-parse --git-dir) || { echo "error: not in a git repo" ; return 1; }
1344 [[ $p != /* ]] && p=$PWD
1345 echo "${p%%/.git}"
1346 }
1347
1348 g() {
1349
1350 # todo: patch emacs so it will look elsewhere. this is kinda sad:
1351 # https://emacs.stackexchange.com/questions/4253/how-to-start-emacs-with-a-custom-user-emacs-directory
1352
1353 local args gdb=false
1354
1355 if [[ $EMACSDIR ]]; then
1356 path-add "$EMACSDIR/lib-src" "$EMACSDIR/src"
1357 fi
1358
1359 if [[ $DISPLAY ]]; then
1360 args=-n
1361 fi
1362
1363 if (( $# == 0 )); then
1364 args+=" -c"
1365 fi
1366 # duplicate -c, but oh well
1367 if ! pgrep -u $EUID emacsclient; then
1368 if (( $# == 0 )) && type -p gdb &>/dev/null; then
1369 gdb=true
1370 else
1371 args+=" -c"
1372 fi
1373 fi
1374 if [[ $EMACSDIR ]]; then
1375 # Alter the path here, otherwise the nfs mount gets triggered on the
1376 # first path lookup when emacs is not being used.
1377 PATH="$EMACSDIR/lib-src:$EMACSDIR/src:$PATH" EHOME=$HOME HOME=$EMACSDIR m emacsclient -a "" $args "$@"
1378 else
1379 if $gdb; then
1380 # due to a bug, we cant debug from the start unless we get a new gdb
1381 # https://sourceware.org/bugzilla/show_bug.cgi?id=24454
1382 # m gdb -ex="set follow-fork-mode child" -ex=r -ex=quit --args emacs --daemon
1383 m emacsclient -a "" $args "$@"
1384 sleep 1
1385 cd /a/opt/emacs-$(distro-name)$(distro-num)
1386 s gdb -p $(pgrep -f 'emacs --daemon') -ex c
1387 cd -
1388 else
1389 m emacsclient -a "" $args "$@"
1390 fi
1391 fi
1392 }
1393
1394 # force terminal version
1395 gn() {
1396 g -n "$@"
1397 }
1398
1399 gmacs() {
1400 # quit will prompt if the program crashes.
1401 gdb -ex=r -ex=quit --args emacs "$@"; r;
1402 }
1403
1404 gdkill() {
1405 # kill the emacs daemon
1406 pk1 emacs --daemon
1407 }
1408
1409 gr() {
1410 grep -iIP --color=auto "$@" || return $?
1411 }
1412 grr() { # grep recursive
1413 # Don't return 1 on nonmatch because this is meant to be
1414 # interactive, not in a conditional.
1415 if [[ ${#@} == 1 ]]; then
1416 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" . || [[ $? == 1 ]]
1417 else
1418 grep --exclude-dir='*.emacs.d' --exclude-dir='*.git' -riIP --color=auto "$@" || [[ $? == 1 ]]
1419 fi
1420 }
1421 ccomp grep gr grr
1422
1423 rg() { grr "$@"; }
1424 ccomp grep rg
1425
1426 # recursive everything. search for files/dirs and lines. rs = easy chars to press
1427 re() {
1428 local query
1429 query="$1"
1430 find "$@" -not \( -name .svn -prune -o -name .git -prune \
1431 -o -name .hg -prune -o -name .editor-backups -prune \
1432 -o -name .undo-tree-history -prune \) 2>/dev/null | grep -iP --color=auto "$query"
1433 grr -m 5 "$@"
1434 }
1435
1436 # horizontal row. used to break up output
1437 hr() {
1438 local blocks
1439 # 180 is long enough.
1440 blocks=██████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
1441 printf "%s\n" "$(tput setaf 5 2>/dev/null ||:)${blocks:0:${COLUMNS:-180}}$(tput sgr0 2>/dev/null||:)"
1442 }
1443 # highlight
1444 hl() {
1445 local col input_len=0
1446 for arg; do
1447 input_len=$((input_len + 1 + ${#arg}))
1448 done
1449 col=$((60 - input_len))
1450 printf "\e[1;97;41m%s" "$*"
1451 if (( col > 0 )); then
1452 printf "\e[1;97;41m \e[0m%.0s" $(eval echo "{1..${col}}")
1453 fi
1454 echo
1455 }
1456 hlm() { hl "$*"; "$@"; }
1457
1458 hrcat() { local f; for f; do [[ -f $f ]] || continue; hr; echo "$f"; cat "$f"; done }
1459
1460
1461 # get latest hub and run it
1462 # main command to use:
1463 # hub pull-request --no-edit
1464 # --no-edit means to use the first commit\'s message as the pull request message.
1465 # If that fails, try doing
1466 # hub pull-request --no-edit -b UPSTREAM_OWNER:branch
1467 # where branch is usually master. it does the pr against your current branch.
1468 #
1469 # On first use, you input username/pass and it gets an oath token so you dont have to repeat
1470 # it\'s at ~/.config/hub
1471 hub() {
1472 local up uptar updir p v
1473 # example https://github.com/github/hub/releases/download/v2.14.2/hub-linux-amd64-2.14.2.tgz
1474 up=$(wget -q -O- https://api.github.com/repos/github/hub/releases/latest | jq -r .assets[].browser_download_url | grep linux-amd64)
1475 re='[[:space:]]'
1476 if [[ ! $up || $up == $re ]]; then
1477 echo "failed to get good update url. got: $up"
1478 fi
1479 uptar=${up##*/}
1480 updir=${uptar%.tgz}
1481 if [[ ! -e /a/opt/$updir ]]; then
1482 rm -rf /a/opt/hub-linux-amd64*
1483 wget -P /a/opt $up
1484 tar -C /a/opt -zxf /a/opt/$uptar
1485 rm -f /a/opt/$uptar
1486 fi
1487 if ! which hub &>/dev/null; then
1488 sudo /a/opt/$updir/install
1489 fi
1490
1491 # save token across computers
1492 if [[ ! -L ~/.config/hub ]]; then
1493 if [[ -e ~/.config/hub ]]; then
1494 mv ~/.config/hub /p/c/subdir_files/.config/
1495 fi
1496 if [[ -e /p/c/subdir_files/.config/hub ]]; then
1497 conflink
1498 fi
1499 fi
1500 command hub "$@"
1501 }
1502
1503 i() { git "$@"; }
1504 ccomp git i
1505
1506 # git status:
1507 # cvs -qn update
1508
1509 # git checkout FILE
1510 # cvs update -C FILE
1511
1512 # git pull
1513 # cvs up[date]
1514
1515 # potentially useful command translation
1516 # https://fling.seas.upenn.edu/~giesen/dynamic/wordpress/equivalent-commands-for-git-svn-and-cvs/
1517
1518 # importing cvs repo into git using git-cvs package:
1519 # /f/www $ /usr/lib/git-core/git-cvsimport -C /f/www-git
1520
1521 ic() {
1522 # fast commit all
1523 git commit -am "$*"
1524 }
1525
1526 ipp() {
1527 git pull
1528 git push
1529 }
1530
1531 ifn() {
1532 local glob
1533 glob="$1"
1534 shift
1535 find -L "$@" -not \( -name .svn -prune -o -name .git -prune \
1536 -o -name .hg -prune -o -name .editor-backups -prune \
1537 -o -name .undo-tree-history -prune \) -iname "*$glob*" 2>/dev/null
1538 }
1539
1540 ifh() {
1541 # insensitive find here. args are combined into the search string.
1542 # -L = follow symlinks
1543 find -L . -not \( -name .svn -prune -o -name .git -prune \
1544 -o -name .hg -prune -o -name .editor-backups -prune \
1545 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1546 }
1547
1548 ifd() {
1549 # insensitive find directory
1550 find -L . -type d -not \( -name .svn -prune -o -name .git -prune \
1551 -o -name .hg -prune -o -name .editor-backups -prune \
1552 -o -name .undo-tree-history -prune \) -iname "*$**" 2>/dev/null
1553 }
1554
1555
1556 ipdrop() {
1557 sudo iptables -A INPUT -s $1 -j DROP
1558 }
1559
1560
1561 istext() {
1562 grep -Il "" "$@" &>/dev/null
1563 }
1564
1565 pst() {
1566 pstree -apnA
1567 }
1568
1569 jtail() {
1570 journalctl -n 10000 -f "$@"
1571 }
1572 jr() { journalctl "$@" ; }
1573 jrf() { journalctl -f "$@" ; }
1574 jru() {
1575 journalctl -u exim4 _SYSTEMD_INVOCATION_ID=$(systemctl show -p InvocationID --value $1)
1576 }
1577
1578
1579
1580 l() {
1581 if [[ $PWD == /[iap] ]]; then
1582 command ls -A --color=auto -I lost+found "$@"
1583 else
1584 command ls -A --color=auto "$@"
1585 fi
1586 }
1587
1588 lcn() { locate -i "*$**"; }
1589
1590 lg() { LC_COLLATE=C.UTF-8 ll --group-directories-first "$@"; }
1591
1592 lt() { ll -tr "$@"; }
1593
1594 lld() { ll -d "$@"; }
1595
1596 ccomp ls l lg lt lld ll
1597
1598 # low recursively
1599 lowr() {
1600 local f dirs i a
1601 local -a all
1602 for dirs in false true; do
1603 for f; do
1604 if [[ -d $f ]]; then
1605 all=("$f"/**)
1606 # reverse the order to rename the nested dirs first.
1607 # note: 0 element is the dir itself
1608 for ((i=${#all[@]}-1; i>=1; i--)); do
1609 a="${all[i]}"
1610 if $dirs && [[ -d $a ]]; then
1611 # e dirs low "$a" # debug
1612 low "$a"
1613 elif ! $dirs && [[ ! -d $a && -e $a ]]; then
1614 # debug
1615 # e not dirs low "$a" # debug
1616 low "$a"
1617 fi
1618 done
1619 fi
1620 # just rename all the top level args on the second pass
1621 if $dirs; then
1622 # e final dirs low "$f" # debug
1623 low "$f"
1624 fi
1625 done
1626 done
1627 }
1628
1629 low() { # make filenames lowercase, remove bad chars
1630 local arg new dir f
1631 for arg; do
1632 arg="${arg%%+(/)}" # remove trailing slashes. assumes we have extglob on.
1633 dir="${arg%/*}"
1634 if (( ${#dir} == ${#arg} )); then
1635 dir=.
1636 fi
1637 f="${arg##*/}"
1638 new="${f,,}" # downcase
1639 new="${new//[^a-zA-Z0-9._-]/_}" # sub bad chars
1640 new="${new#"${new%%[[:alnum:]]*}"}" # remove leading/trailing non-alnum
1641 new="${new%"${new##*[[:alnum:]]}"}"
1642 # remove bad underscores, like __ and _._
1643 new=$(echo $new | sed -r 's/__+/_/g;s/_+([.-])|([.-])_+/\1/g')
1644 safe_rename "$dir/$f" "$dir/$new" || return 1
1645 done
1646 return 0
1647 }
1648
1649 lower() { # make first letter of filenames lowercase.
1650 local x
1651 for x in "$@"; do
1652 if [[ ${x::1} == [A-Z] ]]; then
1653 y=$(tr '[:upper:]' '[:lower:]' <<<"${x::1}")"${x:1}"
1654 safe_rename "$x" "$y" || return 1
1655 fi
1656 done
1657 }
1658
1659
1660 k() { # history search
1661 grep -iP --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | tail -n 80 || [[ $? == 1 ]];
1662 }
1663 ks() { # history search with context
1664 # args are an extended regex used by sed
1665 history | sed -nr "h;s/^\s*(\S+\s+){4}//;/$*/{g;p}" | tail -n 80 || [[ $? == 1 ]];
1666 }
1667 ksu() { # history search unique
1668 grep -P --binary-files=text "$@" ${HISTFILE:-~/.bash_history} | uniq || [[ $? == 1 ]];
1669 }
1670
1671 # todo: id like to do maybe a daily or hourly cronjob to
1672 # check that my history file size is increasing. Ive had it
1673 # inexplicably truncated in the past.
1674 histrm() {
1675 history -n
1676 HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/'
1677 read -r -p "press anything but contrl-c to delete"
1678 for entry in $(HISTTIMEFORMAT= history | awk -v IGNORECASE=1 '{ a=$1; sub(/^ *[^ ]+ */, "") }; /'"$*"'/ { print a }' | tac); do
1679 history -d $entry
1680 done
1681 history -w
1682 }
1683
1684 ccomp grep k ks ksu histrm
1685
1686
1687 make-targets() {
1688 # show make targets, via http://stackoverflow.com/questions/3063507/list-goals-targets-in-gnu-make
1689 make -qp | awk -F':' '/^[a-zA-Z0-9][^$#\/\t=]*:([^=]|$)/ {split($1,A,/ /);for(i in A)print A[i]}'
1690 }
1691
1692 mkc() {
1693 mkdir "$1"
1694 c "$1"
1695 }
1696 ccomp mkdir mkc
1697
1698 mkct() {
1699 mkc $(mktemp -d)
1700 }
1701 # mkdir the last arg, cp the rest into it
1702 mkcp() {
1703 mkdir -p "${@: -1}"
1704 cp "${@:1:$#-1}" "${@: -1}"
1705 }
1706 mkmv() {
1707 mkdir -p "${@: -1}"
1708 mv "${@:1:$#-1}" "${@: -1}"
1709 }
1710
1711 mkt() { # mkdir and touch file
1712 local path="$1"
1713 mkdir -p "$(dirname "$path")"
1714 touch "$path"
1715 }
1716
1717 # shellcheck disable=SC2032
1718 mkdir() { command mkdir -p "$@"; }
1719
1720 nags() {
1721 # https://github.com/HenriWahl/Nagstamon/issues/357
1722 if ! pgrep -f /usr/lib/notification-daemon/notification-daemon >/dev/null; then
1723 /usr/lib/notification-daemon/notification-daemon &
1724 fi
1725 /usr/bin/nagstamon &
1726 }
1727
1728 nmt() {
1729 # cant use s because sudo -i doesnt work for passwordless sudo command
1730 case $EUID in
1731 0)
1732 sudo nmtui-connect "$@"
1733 ;;
1734 *)
1735 nmtui-connect "$@"
1736 ;;
1737 esac
1738 }
1739
1740
1741 ngset() {
1742 if shopt nullglob >/dev/null; then
1743 ngreset=false
1744 else
1745 shopt -s nullglob
1746 ngreset=true
1747 fi
1748 }
1749 ngreset() {
1750 if $ngreset; then
1751 shopt -u nullglob
1752 fi
1753 }
1754
1755 nopanic() {
1756 # shellcheck disable=SC2024
1757 ngset
1758 for f in /var/log/exim4/paniclog /var/log/exim4/*panic; do
1759 base=${f##*/}
1760 if [[ -s $f ]]; then
1761 echo ================== $f =============
1762 s tee -a /var/log/exim4/$base-archive <$f
1763 s truncate -s0 $f
1764 fi
1765 done
1766 ngreset
1767 }
1768
1769
1770 ping() { command ping -O "$@"; }
1771 p8() { ping "$@" 8.8.8.8; }
1772 p6() { ping6 "$@" 2001:4860:4860::8888; }
1773
1774 pkx() { # package extract
1775 local pkg cached tmp f
1776 c $(mktemp -d)
1777 pkg=$1
1778 # shellcheck disable=SC2012
1779 cached=$(ls -t /var/cache/apt/archives/$pkg* | tail -n1 2>/dev/null) ||:
1780 if [[ $cached ]]; then
1781 cp $cached .
1782 else
1783 aptitude download $pkg || return 1
1784 fi
1785 tmp=(*); f=${tmp[0]} # only 1 expected
1786 ex $f
1787 rm -f $f
1788 }
1789
1790 # pgrep and kill
1791 pk1() {
1792 local pid
1793 pid=($(pgrep -f "$*"))
1794 case ${#pid[@]} in
1795 1)
1796 # shellcheck disable=SC2128
1797 {
1798 ps -F $pid
1799 m kill $pid
1800 }
1801 ;;
1802 0) echo "no pid found" ;;
1803 *)
1804 ps -F ${pid[@]}
1805 ;;
1806 esac
1807 }
1808
1809 psg () {
1810 local x y help
1811 help="Usage: psg [--help] GREP_ARGS
1812 grep ps and output in a nice format"
1813 if [[ $1 == --help ]]; then
1814 echo "$help"
1815 return
1816 fi
1817 x=$(ps -eF)
1818 # final grep is because some commands tend to have a lot of trailing spaces
1819 y=$(echo "$x" | grep -iP "$@" | grep -o '.*[^ ]') ||:
1820 if [[ $y ]]; then
1821 echo "$x" | head -n 1 || [[ $? == 141 ]]
1822 echo "$y"
1823 fi
1824 }
1825
1826 pubip() { curl -4s https://icanhazip.com; }
1827 pubip6() { curl -6s https://icanhazip.com; }
1828 whatismyip() { pubip; }
1829
1830
1831 q() { # start / launch a program in the backround and redir output to null
1832 "$@" &> /dev/null &
1833 }
1834
1835 # shellcheck disable=SC2120
1836 r() {
1837 if [[ $HISTFILE ]]; then
1838 history -a # save history
1839 fi
1840 trap ERR # this avoids a segfault
1841 exit ${1:0}
1842 # i had this redir, not sure why
1843 # exit "$@" 2>/dev/null
1844 }
1845
1846 # scp is insecure and deprecated.
1847 scp() {
1848 rsync -Pt --inplace "$@"
1849 }
1850 ccomp rsync scp
1851
1852 randport() {
1853 # available high ports are 1024-65535,
1854 # but lets skip things that are more likely to be in use
1855 python3 <<'EOF'
1856 import secrets
1857 print(secrets.SystemRandom().randrange(10002,65500))
1858 EOF
1859 }
1860
1861 # reapply bashrc
1862 reb() {
1863 source ~/.bashrc
1864 }
1865
1866 rl() {
1867 readlink -f "$@"
1868 }
1869 ccomp readlink rl
1870
1871 rsd() {
1872 # rsync, root is required to keep permissions right.
1873 # rsync --archive --human-readable --verbose --itemize-changes --checksum \(-ahvic\) \
1874 # --no-times --delete
1875 # basically, make an exact copy, use checksums instead of file times to be more accurate
1876 rsync -ahvic --delete "$@"
1877 }
1878 rsa() {
1879 # like rlu, but dont delete files on the target end which
1880 # do not exist on the original end.
1881 rsync -ahvic "$@"
1882 }
1883 rst() {
1884 # rl without preserving modification time.
1885 rsync -ahvic --delete --no-t "$@"
1886 }
1887 # [RSYNC_OPTS] HOST PATH
1888 rsu() {
1889 # eg. rsu -opts frodo /testpath
1890 # relative paths will expanded with readlink -f.
1891 opts=("${@:1:$#-2}") # 1 to last -2
1892 path="${*:$#}" # last
1893 host="${*:$#-1:1}" # last -1
1894 if [[ $path == .* ]]; then
1895 path=$(readlink -f $path)
1896 fi
1897 m rsync -ahvi --relative --no-implied-dirs "${opts[@]}" "$path" "root@$host:/";
1898 }
1899 ccomp rsync rsd rsa rst rsu
1900
1901 # find programs listening on a port
1902 ssp() {
1903 local port=$1
1904 # to figure out these args, i had to look at the man page from git version, as of 2022-04.
1905 s ss -lpn state listening sport = $port
1906 }
1907
1908 resolvcat() {
1909 local f
1910 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1911 m s nscd -i hosts
1912 fi
1913 f=/etc/resolv.conf
1914 echo $f:; ccat $f
1915 hr; s ss -lpn sport = 53
1916 if systemctl is-enabled dnsmasq &>/dev/null || [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1917 # this will fail is dnsmasq is failed
1918 hr; m ser status dnsmasq | cat || :
1919 f=/etc/dnsmasq.conf
1920 hr; echo $f:; ccat $f
1921 hr; m grr '^ *(servers-file|server) *=|^ *no-resolv *$' /etc/dnsmasq.conf /etc/dnsmasq.d
1922 f=/etc/dnsmasq-servers.conf
1923 hr; echo $f:; ccat $f
1924 fi
1925 hr
1926 echo /etc/nsswitch.conf:
1927 grep '^ *hosts:' /etc/nsswitch.conf
1928 if systemctl is-enabled systemd-resolved &>/dev/null || [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1929 hr; m ser status systemd-resolved | cat || :
1930 hr; m resolvectl status | cat
1931 fi
1932
1933 }
1934 rcat() {
1935 resolvcat | less
1936 }
1937 reresolv() {
1938 if [[ $(systemctl is-active nscd ||:) != inactive ]]; then
1939 m ser stop nscd
1940 sleep .5
1941 m ser start nscd
1942 m sudo nscd -i hosts
1943 fi
1944 if [[ $(systemctl is-active dnsmasq ||:) != inactive ]]; then
1945 m sudo systemctl restart dnsmasq
1946 fi
1947 if [[ $(systemctl is-active systemd-resolved ||:) != inactive ]]; then
1948 m sudo systemctl restart systemd-resolved
1949 fi
1950 if type -P resolvectl &>/dev/null; then
1951 resolvectl flush-caches
1952 fi
1953 }
1954
1955 # add annoyingly long argument which should be the default
1956 sedi() {
1957 sed -i --follow-symlinks "$@"
1958 }
1959
1960 rmstrips() {
1961 ssh fencepost head -n 300 /gd/gnuorg/EventAndTravelInfo/rms-current-trips.txt | less
1962 }
1963
1964 urun () {
1965 umask $1
1966 shift
1967 "$@"
1968 }
1969 sudo () {
1970 command sudo "$@" || return $?
1971 DID_SUDO=true
1972 }
1973 s() {
1974 # background
1975 # I use a function because otherwise we cant use in a script,
1976 # cant assign to variable.
1977 #
1978 # note: gksudo is recommended for X apps because it does not set the
1979 # home directory to the same, and thus apps writing to ~ fuck things up
1980 # with root owned files.
1981 #
1982 if [[ $EUID != 0 || $1 == -* ]]; then
1983 # shellcheck disable=SC2034
1984 SUDOD="$PWD" command sudo -i "$@"
1985 DID_SUDO=true
1986 else
1987 "$@"
1988 fi
1989 }
1990 sb() { # sudo bash -c
1991 # use sb instead of s is for sudo redirections,
1992 # eg. sb 'echo "ok fine" > /etc/file'
1993 # shellcheck disable=SC2034
1994 local SUDOD="$PWD"
1995 sudo -i bash -c "$@"
1996 }
1997 # secret sudo
1998 se() { s urun 0077 "$@"; }
1999 ccomp sudo s sb se
2000
2001 safe_rename() { # warn and dont rename if file exists.
2002 # mv -n exists, but it\'s silent
2003 if [[ $# != 2 ]]; then
2004 echo safe_rename error: $# args, need 2 >2
2005 return 1
2006 fi
2007 if [[ $1 != "$2" ]]; then # yes, we want to silently ignore this
2008 if [[ -e $2 || -L $2 ]]; then
2009 echo "Cannot rename $1 to $2 as it already exists."
2010 else
2011 mv -vi "$1" "$2"
2012 fi
2013 fi
2014 }
2015
2016
2017 sd() {
2018 sudo dd status=none of="$1"
2019 }
2020
2021 ser() {
2022 if type -p systemctl &>/dev/null; then
2023 s systemctl "$@"
2024 else
2025 if (( $# >= 3 )); then
2026 echo iank: ser expected 2 or less arguments
2027 return 1
2028 fi
2029 s service $2 $1
2030 fi
2031 }
2032 serstat() {
2033 systemctl -n 40 status "$@"
2034 }
2035
2036 seru() { systemctl --user "$@"; }
2037 # like restart, but do nothing if its not already started
2038 srestart() {
2039 local service=$1
2040 if [[ $(s systemctl --no-pager show -p ActiveState $service ) == ActiveState=active ]]; then
2041 systemctl restart $service
2042 fi
2043 }
2044
2045 setini() { # set a value in a .ini style file
2046 key="$1" value="$2" section="$3" file="$4"
2047 if [[ -s $file ]]; then
2048 sed -ri -f - "$file" <<EOF
2049 # remove existing keys
2050 / *\[$section\]/,/^ *\[[^]]+\]/{/^\s*$key[[:space:]=]/d}
2051 # add key
2052 /^\s*\[$section\]/a $key=$value
2053 # from section to eof, do nothing
2054 /^\s*\[$section\]/,\$b
2055 # on the last line, if we haven't found section yet, add section and key
2056 \$a [$section]\\
2057 $key=$value
2058 EOF
2059 else
2060 cat >"$file" <<EOF
2061 [$section]
2062 $key=$value
2063 EOF
2064 fi
2065 }
2066
2067 sgo() { # service go
2068 service=$1
2069 ser restart $service || return 1
2070 if type -p systemctl &>/dev/null; then
2071 ser enable $service
2072 fi
2073 }
2074 soff () {
2075 for service; do
2076 # ignore services that dont exist
2077 if systemctl cat $service &>/dev/null; then
2078 ser stop $service;
2079 ser disable $service
2080 fi
2081 done
2082 }
2083
2084 sgu() {
2085 systemctl list-unit-files | rg "$@"
2086 }
2087
2088
2089 sk() {
2090
2091
2092 # disable a warning with:
2093 # shellcheck disable=SC2206 # reasoning
2094
2095 # see bash-template/style-guide.md for justifications
2096
2097 local quotes others
2098 quotes=2048,2068,2086,2206
2099 others=2029,2033,2054,2164
2100 shellcheck -W 999 -x -e $quotes,$others "$@" || return $?
2101 }
2102
2103
2104 # sl: ssh, but firsh rsync our bashrc and related files to a special
2105 # directory on the remote host if needed.
2106
2107 # Some environment variables and files need to be setup for this to work
2108 # (mine are set at the beginning of this file)
2109
2110 # SL_FILES_DIR: Environment variable. Path to folder which should at
2111 # least have a .bashrc file or symlink. This dir will be rsynced to ~ on
2112 # remote hosts (top level symlinks are resolved) unless the host already
2113 # has a $SL_FILES_DIR/.bashrc. In that case, we assume it is a host you
2114 # control and sync files to separately and already has the ~/.bashrc you
2115 # want. The remote bash will also take its .inputrc config from this
2116 # folder (default of not existing is fine). Mine looks like this:
2117 # https://iankelling.org/git/?p=distro-setup;a=tree;f=sl/.iank
2118
2119 # SL_INFO_DIR: Environment variable. This folder stores info about what
2120 # we detected on the remote system and when we last synced. It will be created
2121 # if it does not exist. Sometimes you may want to forget about a
2122 # remote system, you can use sl --rsync, or the function for that slr
2123 # below.
2124
2125 # SL_TEST_CMD: Env var. Meant to be used to vary the files synced
2126 # depending on the remote host. Run this string on the remote host the
2127 # first time sl is run (or if we run slr). The result is passed to
2128 # SL_TEST_HOOK. For example,
2129 # export SL_TEST_CMD=". /etc/os-release ; echo \${VERSION//[^a-zA-Z0-9]/}"
2130
2131 # SL_TEST_HOOK: Env var. It is run as $SL_TEST_HOOK. This can set
2132 # $SL_FILES_DIR to vary the files synced.
2133
2134 # SL_RSYNC_ARGS: Env var. String of arguments passed to rsync. For
2135 # example to exclude files within a directory. Note, excluded
2136 # files wont be deleted on rsync, you can add --delete-excluded
2137 # to the rsync command if that is desired.
2138
2139 # SL_SSH_ARGS: Env var. Default arguments passed to ssh.
2140
2141 # For when ~/.bashrc is already customized on the remote server, you
2142 # might find it problematic that ~/.bashrc is sourced for ALL ssh
2143 # commands, even in scripts. This paragraph is all about that. bash
2144 # scripts dont source ~/.bashrc, but call ssh in scripts and you get
2145 # ~/.bashrc. You dont want this. .bashrc is meant for interactive shells
2146 # and if you customize it, probably has bugs from time to time. This is
2147 # bad. Here's how I fix it. I have a special condition to "return" in my
2148 # .bashrc for noninteractive ssh shells (copy that code). Then use this
2149 # function or similar that passes LC_USEBASHRC=t when sshing and I want
2150 # my bashrc. Also, I don't keep most of my bashrc in .bashrc, i source a
2151 # separate file because even if I return early on, the whole file gets
2152 # parsed which can fail if there is a syntax error.
2153 sl() {
2154 # Background on LC_USEBASHRC var (no need to read if you just want to
2155 # use this function): env variables sent across ssh are strictly
2156 # limited, but we get LC_* at least in debian based machines, so we
2157 # just make that * be something no normal program would use. Note, on
2158 # hosts that dont allow LC_* I start an inner shell with LC_USEBASHRC
2159 # set, and the inner shell also allows running a nondefault
2160 # .bashrc. This means the outer shell still ran the default .bashrc,
2161 # but that is the best we can do.
2162
2163 local now args remote dorsync haveinfo tmpa sshinfo tmp tmp2 type info_sec force_rsync \
2164 sync_dirname testcmd extra_info testbool files_sec sl_test_cmd sl_test_hook
2165 declare -a args tmpa
2166
2167 args=($SL_SSH_ARGS)
2168
2169 # ssh [-1246Antivivisectionist] [-b bind_address] [-c cipher_spec] [-D [bind_address:]port]
2170 # [-E log_file] [-e escape_char] [-F configfile] [-I pkcs11] [-i identity_file] [-L address]
2171 # [-l login_name] [-m mac_spec] [-O ctl_cmd] [-o option] [-p port] [-Q query_option]
2172 # [-R address] [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]] [user@]hostname
2173 # [command]
2174
2175 # ssh [-46AaCfGgKkMNnqsTtVvXxYy] [-b bind_address] [-c cipher_spec]
2176 # [-D [bind_address:]port] [-E log_file] [-e escape_char]
2177 # [-F configfile] [-I pkcs11] [-i identity_file]
2178 # [-J [user@]host[:port]] [-L address] [-l login_name] [-m mac_spec]
2179 # [-O ctl_cmd] [-o option] [-p port] [-Q query_option] [-R address]
2180 # [-S ctl_path] [-W host:port] [-w local_tun[:remote_tun]]
2181
2182 force_rsync=false
2183 if [[ $1 == --rsync ]]; then
2184 force_rsync=true
2185 shift
2186 fi
2187
2188 sl_test_cmd=$SL_TEST_CMD
2189 sl_test_hook=$SL_TEST_HOOK
2190 sl_rsync_args=$SL_RSYNC_ARGS
2191 while [[ $1 ]]; do
2192 case "$1" in
2193 --rsync)
2194 force_rsync=true
2195 ;;
2196 --sl-test-cmd)
2197 sl_test_cmd="$2"
2198 shift
2199 ;;
2200 --sl-test-hook)
2201 sl_test_hook="$2"
2202 shift
2203 ;;
2204 --sl-rsync-args)
2205 sl_rsync_args="$2"
2206 shift
2207 ;;
2208 *)
2209 break
2210 ;;
2211 esac
2212 shift
2213 done
2214
2215 while [[ $1 ]]; do
2216 case "$1" in
2217 # note we dont support things like -4oOption
2218 -[46AaCfGgKkMNnqsTtVvXxYy]*)
2219 args+=("$1"); shift
2220 ;;
2221 -[bcDEeFIiJLlmOopQRSWw]*)
2222 # -oOption etc is valid
2223 if (( ${#1} >= 3 )); then
2224 args+=("$1"); shift
2225 else
2226 args+=("$1" "$2"); shift 2
2227 fi
2228 ;;
2229 *)
2230 break
2231 ;;
2232 esac
2233 done
2234 remote="$1"
2235 if [[ ! $remote ]]; then
2236 echo $0: error hostname required >&2
2237 return 1
2238 fi
2239 shift
2240
2241 if [[ ! $SL_INFO_DIR ]]; then
2242 echo error: missing '$SL_INFO_DIR' env var >&2
2243 return 1
2244 fi
2245
2246 dorsync=false
2247 haveinfo=false
2248 tmpa=($SL_INFO_DIR/???????????"$remote")
2249 sshinfo=${tmpa[0]}
2250 if [[ -e $sshinfo ]]; then
2251 if $force_rsync; then
2252 rm -f $sshinfo
2253 else
2254 haveinfo=true
2255 fi
2256 fi
2257 if $haveinfo; then
2258 tmp=${sshinfo[0]##*/}
2259 tmp2=${tmp::11}
2260 type=${tmp2: -1}
2261 extra_info=$(cat $sshinfo)
2262 else
2263 # we test for string to know ssh succeeded
2264 testbool="test -e $SL_FILES_DIR/.bashrc -a -L .bashrc -a -v LC_USEBASHRC"
2265 testcmd="if $testbool; then printf y; else printf n; fi"
2266 if ! tmp=$(LC_USEBASHRC=y command ssh "${args[@]}" "$remote" "$testcmd; $sl_test_cmd"); then
2267 echo failed sl test. doing plain ssh -v
2268 command ssh -v "${args[@]}" "$remote"
2269 fi
2270 if [[ $tmp == y* ]]; then
2271 type=a
2272 else
2273 dorsync=true
2274 type=b
2275 fi
2276 extra_info="${tmp:1}"
2277 fi
2278 if [[ $sl_test_hook ]]; then
2279 RSYNC_RSH="ssh ${args[*]}" $sl_test_hook "$extra_info" "$remote"
2280 fi
2281
2282 if $haveinfo && [[ $type == b ]]; then
2283 info_sec=${tmp::10}
2284 read files_sec _ < <(find -L $SL_FILES_DIR -printf "%T@ %p\n" | sort -nr || [[ $? == 141 || ${PIPESTATUS[0]} == 32 ]] )
2285 files_sec=${files_sec%%.*}
2286 if (( files_sec > info_sec )); then
2287 dorsync=true
2288 rm -f $sshinfo
2289 fi
2290 fi
2291
2292 sync_dirname=${SL_FILES_DIR##*/}
2293
2294 if [[ ! $SL_FILES_DIR ]]; then
2295 echo error: missing '$SL_FILES_DIR' env var >&2
2296 return 1
2297 fi
2298
2299 if $dorsync; then
2300 RSYNC_RSH="ssh ${args[*]}" m rsync -rptL --delete $sl_rsync_args $SL_FILES_DIR "$remote":
2301 fi
2302 if $dorsync || ! $haveinfo; then
2303 sshinfo=$SL_INFO_DIR/$EPOCHSECONDS$type"$remote"
2304 [[ -e $SL_INFO_DIR ]] || mkdir -p $SL_INFO_DIR
2305 printf "%s\n" "$extra_info" >$sshinfo
2306 chmod 666 $sshinfo
2307 fi
2308 if [[ $type == b ]]; then
2309 if (( ${#@} )); then
2310 # Theres a couple ways to pass arguments, im not sure whats best,
2311 # but relying on bash 4.4+ escape quoting seems most reliable.
2312 command ssh "${args[@]}" "$remote" \
2313 LC_USEBASHRC=t bash -c '.\ '$sync_dirname'/.bashrc\;"\"\$@\""' bash ${@@Q}
2314 elif [[ ! -t 0 ]]; then
2315 # This case is when commands are being piped to ssh.
2316 # Normally, no bashrc gets sourced.
2317 # But, since we are doing all this, lets source it because we can.
2318 cat <(echo . $sync_dirname/.bashrc) - | command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2319 else
2320 command ssh -t "${args[@]}" "$remote" LC_USEBASHRC=t INPUTRC=$sync_dirname/.inputrc bash --rcfile $sync_dirname/.bashrc
2321 fi
2322 else
2323 if [[ -t 0 ]]; then
2324 LC_USEBASHRC=t command ssh "${args[@]}" "$remote" ${@@Q}
2325 else
2326 command ssh "${args[@]}" "$remote" LC_USEBASHRC=t bash
2327 fi
2328 fi
2329 # this function inspired from https://github.com/Russell91/sshrc
2330 }
2331
2332 slr() {
2333 sl --rsync "$@"
2334 }
2335 sss() { # ssh solo
2336 sl -oControlMaster=no -oControlPath=/ "$@"
2337 }
2338 # kill off old shared socket then ssh
2339 ssk() {
2340 m ssh -O exit "$@" || [[ $? == 255 ]]
2341 m sl "$@"
2342 }
2343 ccomp ssh sl slr sss ssk
2344 # plain ssh
2345 ssh() {
2346 if [[ $TERM == alacritty || $TERM == xterm-kitty ]]; then
2347 TERM=xterm-256color LC_USEBASHRC=t command ssh "$@"
2348 else
2349 LC_USEBASHRC=t command ssh "$@"
2350 fi
2351 }
2352
2353
2354 slog() {
2355 # log with script. timing is $1.t and script is $1.s
2356 # -l to save to ~/typescripts/
2357 # -t to add a timestamp to the filenames
2358 local logdir do_stamp arg_base
2359 (( $# >= 1 )) || { echo "arguments wrong"; return 1; }
2360 logdir="/a/dt/"
2361 do_stamp=false
2362 while getopts "lt" option
2363 do
2364 case $option in
2365 l ) arg_base=$logdir ;;
2366 t ) do_stamp=true ;;
2367 esac
2368 done
2369 shift $((OPTIND - 1))
2370 arg_base+=$1
2371 [[ -e $logdir ]] || mkdir -p $logdir
2372 $do_stamp && arg_base+=$(date +%F.%T%z)
2373 script -t $arg_base.s 2> $arg_base.t
2374 }
2375 splay() { # script replay
2376 #logRoot="$HOME/typescripts/"
2377 #scriptreplay "$logRoot$1.t" "$logRoot$1.s"
2378 scriptreplay "$1.t" "$1.s"
2379 }
2380
2381 sr() {
2382 # sudo redo. be aware, this command may not work right on strange distros or earlier software
2383 if [[ $# == 0 ]]; then
2384 sudo -E bash -c -l "$(history -p '!!')"
2385 else
2386 echo this command redos last history item. no argument is accepted
2387 fi
2388 }
2389
2390 srm () {
2391 # with -ll, less secure but faster.
2392 command srm -ll "$@"
2393 }
2394
2395 srun() {
2396 scp $2 $1:/tmp
2397 ssh $1 /tmp/${2##*/} $(printf "%q\n" "${@:2}")
2398 }
2399
2400
2401 swap() {
2402 local tmp
2403 tmp=$(mktemp)
2404 mv $1 $tmp
2405 mv $2 $1
2406 mv $tmp $2
2407 }
2408
2409 tclock() { # terminal clock
2410 local x
2411 clear
2412 date +%l:%_M
2413 len=60
2414 # this goes to full width
2415 #len=${1:-$((COLUMNS -7))}
2416 x=1
2417 while true; do
2418 if (( x == len )); then
2419 end=true
2420 d="$(date +%l:%_M) "
2421 else
2422 end=false
2423 d=$(date +%l:%M:%_S)
2424 fi
2425 echo -en "\r"
2426 echo -n "$d"
2427 for ((i=0; i<x; i++)); do
2428 if (( i % 6 )); then
2429 echo -n _
2430 else
2431 echo -n .
2432 fi
2433 done
2434 if $end; then
2435 echo
2436 x=1
2437 else
2438 x=$((x+1))
2439 fi
2440 sleep 5
2441 done
2442 }
2443
2444
2445 te() {
2446 # test existence / exists
2447 local ret=0
2448 for x in "$@"; do
2449 [[ -e "$x" || -L "$x" ]] || ret=1
2450 done
2451 return $ret
2452 }
2453
2454 psoff() {
2455 # normally, i would just execute these commands in the function.
2456 # however, DEBUG is not inherited, so we need to run it outside a function.
2457 # And we want to run set -x afterwards to avoid spam, so we cram everything
2458 # in here, and then it will run after this function is done.
2459 PROMPT_COMMAND='trap DEBUG; unset PROMPT_COMMAND; PS1="\w \$ "'
2460 }
2461 pson() {
2462 PROMPT_COMMAND=prompt-command
2463 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2464 trap 'settitle "$BASH_COMMAND"' DEBUG
2465 fi
2466 }
2467
2468 # prometheus node curl
2469 pnodecurl() {
2470 local host
2471 host=${1:-127.0.0.1}
2472 s curl --cert-type PEM --cert /etc/prometheus/ssl/prometheus_cert.pem --key /etc/prometheus/ssl/prometheus_key.pem --cacert /etc/prometheus/ssl/prom_node_cert.pem --resolve prom_node:9100:$host -v https://prom_node:9100/metrics
2473 }
2474
2475 tx() { # toggle set -x, and the prompt so it doesnt spam
2476 if [[ $- == *x* ]]; then
2477 set +x
2478 pson
2479 else
2480 psoff
2481 fi
2482 }
2483
2484 psnetns() {
2485 # show all processes in the network namespace $1.
2486 # blank entries appear to be subprocesses/threads
2487 local x netns
2488 netns=$1
2489 ps -w | head -n 1
2490 sudo find -L /proc/[1-9]*/task/*/ns/net -samefile /run/netns/$netns | cut -d/ -f5 | \
2491 while read -r l; do
2492 x=$(ps -w --no-headers -p $l);
2493 if [[ $x ]]; then echo "$x"; else echo $l; fi;
2494 done
2495 }
2496 nonet() {
2497 if ! s ip netns list | grep -Fx nonet &>/dev/null; then
2498 s ip netns add nonet
2499 fi
2500 sudo -E env /sbin/ip netns exec nonet sudo -E -u iank /bin/bash
2501 }
2502
2503 m() { printf "%s\n" "$*"; "$@"; }
2504
2505 # update file. note: duplicated in mail-setup
2506 u() {
2507 local tmp tmpdir dest="$1"
2508 local base="${dest##*/}"
2509 local dir="${dest%/*}"
2510 if [[ $dir != "$base" ]]; then
2511 # dest has a directory component
2512 mkdir -p "$dir"
2513 fi
2514 ur=false # u result
2515 tmpdir=$(mktemp -d)
2516 cat >$tmpdir/"$base"
2517 tmp=$(rsync -ic $tmpdir/"$base" "$dest")
2518 if [[ $tmp ]]; then
2519 printf "%s\n" "$tmp"
2520 ur=true
2521 if [[ $dest == /etc/systemd/system/* ]]; then
2522 reload=true
2523 fi
2524 fi
2525 rm -rf $tmpdir
2526 }
2527
2528
2529 uptime() {
2530 if type -p uprecords &>/dev/null; then
2531 uprecords -B
2532 else
2533 command uptime
2534 fi
2535 }
2536
2537 virshrm() {
2538 for x in "$@"; do virsh destroy "$x"; virsh undefine "$x"; done
2539 }
2540
2541 vm-set-listen(){
2542 local t
2543 t=$(mktemp)
2544 local vm=$1
2545 local ip=$2
2546 sudo virsh dumpxml $vm | sed -r "s/(<listen.*address=')([^']+)/\1$ip/" | \
2547 sed -r "s/listen='[^']+/listen='$ip/"> $t
2548 sudo virsh undefine $vm
2549 sudo virsh define $t
2550 }
2551
2552
2553 vmshare() {
2554 vm-set-listen $1 0.0.0.0
2555 }
2556
2557
2558 vmunshare() {
2559 vm-set-listen $1 127.0.0.1
2560 }
2561
2562 myiwscan() {
2563 # find input, copy to pattern space, when we find the first field, print the copy in different order without newlines.
2564 # instead of using labels, we could just match a line and group, eg: /signal:/,{s/signal:(.*)/\1/h}
2565 sudo iw dev wls1 scan | sed -rn "
2566 s/^\Wcapability: (.*)/\1/;Ta;h;b
2567 :a;s/^\Wsignal: -([^.]+).*/\1/;Tb;H;b
2568 # padded to min width of 20
2569 :b;s/\WSSID: (.*)/\1 /;T;s/^(.{20}(.*[^ ])?) */\1/;H;g;s/(.*)\n(.*)\n(.*)/\2 \3 \1/gp;b
2570 "|sort -r
2571 }
2572
2573 # Run script by copying it to a temporary location first,
2574 # and changing directory, so we don't have any open
2575 # directories or files that could cause problems when
2576 # remounting.
2577 zr() {
2578 local tmp
2579 tmp=$(type -p "$1")
2580 if [[ $tmp ]]; then
2581 cd $(mktemp -d)
2582 cp -a "$tmp" .
2583 shift
2584 ./"${tmp##*/}" "$@"
2585 else
2586 "$@"
2587 fi
2588 }
2589
2590
2591 # * spark
2592 # spark 1 5 22 13 53
2593 # # => ▁▁▃▂▇
2594
2595 # The MIT License
2596 # Copyright (c) Zach Holman, https://zachholman.com
2597 # https://github.com/holman/spark
2598
2599 # As of 2022-10-28, I reviewed github forks that had several newer
2600 # commits, none had anything interesting. I did a little refactoring
2601 # mostly to fix emacs indent bug.
2602
2603 # Generates sparklines.
2604 _spark_echo()
2605 {
2606 if [ "X$1" = "X-n" ]; then
2607 shift
2608 printf "%s" "$*"
2609 else
2610 printf "%s\n" "$*"
2611 fi
2612 }
2613
2614
2615 spark()
2616 {
2617 local f tc
2618 local n numbers=
2619
2620 # find min/max values
2621 local min=0xffffffff max=0
2622
2623 for n in ${@//,/ }
2624 do
2625 # on Linux (or with bash4) we could use `printf %.0f $n` here to
2626 # round the number but that doesn't work on OS X (bash3) nor does
2627 # `awk '{printf "%.0f",$1}' <<< $n` work, so just cut it off
2628 n=${n%.*}
2629 (( n < min )) && min=$n
2630 (( n > max )) && max=$n
2631 numbers=$numbers${numbers:+ }$n
2632 done
2633
2634 # print ticks
2635 local ticks=(▁ ▂ ▃ ▄ ▅ ▆ ▇ █)
2636
2637 # use a high tick if data is constant
2638 (( min == max )) && ticks=(▅ ▆)
2639
2640 tc=${#ticks[@]}
2641 f=$(( ( (max-min) <<8)/( tc - 1) ))
2642 (( f < 1 )) && f=1
2643
2644 for n in $numbers
2645 do
2646 _spark_echo -n ${ticks[$(( ((($n-$min)<<8)/$f) ))]}
2647 done
2648 _spark_echo
2649 }
2650
2651 pdfwc() { local f; for f; do echo "$f" $(pdfinfo "$f" | awk '/^Pages:/ {print $2}'); done }
2652
2653 # * misc stuff
2654
2655
2656 if $use_color && type -p tput &>/dev/null; then
2657 term_bold="$(tput bold)"
2658 term_red="$(tput setaf 1)"
2659 term_green="$(tput setaf 2)"
2660 term_yellow="$(tput setaf 3)"
2661 term_purple="$(tput setaf 5)"
2662 term_nocolor="$(tput sgr0)" # no font attributes
2663
2664 # unused so far. commented for shellcheck
2665 # term_underl="$(tput smul)"
2666 # term_blue="$(tput setaf 4)"
2667 # term_cyan="$(tput setaf 6)"
2668 fi
2669 # Try to keep environment pollution down, EPA loves us.
2670 unset safe_term match_lhs use_color
2671
2672 # * prompt
2673
2674
2675 if [[ $- == *i* ]]; then
2676
2677
2678 case $HOSTNAME in
2679 bk|je|li)
2680 if [[ $EUID == 1000 ]]; then
2681 system-status _ ||:
2682 fi
2683 ;;
2684 esac
2685
2686
2687 # this needs to come before next ps1 stuff
2688 # this stuff needs bash 4, feb 2009,
2689 # old enough to no longer condition on $BASH_VERSION anymore
2690 shopt -s autocd
2691 shopt -s dirspell
2692 PS1='\w'
2693 if [[ $- == *i* ]] && [[ ! $LC_INSIDE_EMACS ]]; then
2694 PROMPT_DIRTRIM=2
2695 bind -m vi-command B:shell-backward-word
2696 bind -m vi-command W:shell-forward-word
2697 fi
2698
2699 if [[ $SSH_CLIENT || $SUDO_USER ]]; then
2700 unset PROMPT_DIRTRIM
2701 PS1="\h:$PS1"
2702 fi
2703
2704 # emacs terminal has problems if this runs slowly,
2705 # so I've thrown a bunch of things at the wall to speed it up.
2706 prompt-command() {
2707 local return=$? # this MUST COME FIRST
2708 local ps_char ps_color
2709 unset IFS
2710
2711 if [[ $HISTFILE ]]; then
2712 history -a # save history
2713 fi
2714
2715 case $return in
2716 0) ps_color="$term_purple"
2717 ps_char='\$'
2718 ;;
2719 *) ps_color="$term_green"
2720 ps_char="$return \\$"
2721 ;;
2722 esac
2723 if [[ ! -O . ]]; then # not owner
2724 if [[ -w . ]]; then # writable
2725 ps_color="$term_bold$term_red"
2726 else
2727 ps_color="$term_bold$term_green"
2728 fi
2729 fi
2730
2731 # faster than sourceing the file im guessing
2732 if [[ -e /dev/shm/iank-status && ! -e /tmp/quiet-status ]]; then
2733 eval $(< /dev/shm/iank-status)
2734 fi
2735 if [[ $MAIL_HOST && $MAIL_HOST != "$HOSTNAME" ]]; then
2736 ps_char="@ $ps_char"
2737 fi
2738 jobs_char=
2739 if [[ $(jobs -p) ]]; then
2740 jobs_char='j\j '
2741 fi
2742 # We could test if sudo is active with sudo -nv
2743 # but then we get an email and log of lots of failed sudo commands.
2744 # We could turn those off, but seems better not to.
2745 if [[ $EUID != 0 ]] && [[ $DID_SUDO ]]; then
2746 psudo="\[$term_bold$term_red\]s\[$term_nocolor\] "
2747 fi
2748 if [[ ! $HISTFILE ]]; then
2749 ps_char="NOHIST $ps_char"
2750 fi
2751 PS1="${PS1%"${PS1#*[wW]}"} $jobs_char$psudo\[$ps_color\]$ps_char\[$term_nocolor\] "
2752
2753 # set titlebar. instead, using more advanced
2754 # titelbar below
2755 #echo -ne "$_title_escape $HOSTNAME ${PWD/#$HOME/~} \007"
2756 }
2757 PROMPT_COMMAND=prompt-command
2758
2759 if [[ $TERM == screen* ]]; then
2760 _title_escape="\033]..2;"
2761 else
2762 # somme sites recommend this, i dunno what the diff is.
2763 #_title_escape="\033]30;"
2764 _title_escape="\033]0;"
2765 fi
2766
2767 # make the titlebar be the last command and the current directory.
2768 settitle () {
2769
2770
2771 # These are some checks to help ensure we dont set the title at
2772 # times that the debug trap is running other than the case we
2773 # want. Some of them might not be needed.
2774 if (( ${#FUNCNAME[@]} != 1 || ${#BASH_ARGC[@]} != 2 || $BASH_SUBSHELL != 0 )); then
2775 return 0
2776 fi
2777 if [[ $1 == prompt-command ]]; then
2778 return 0
2779 fi
2780 echo -ne "$_title_escape ${PWD/#$HOME/~} "
2781 printf "%s" "$*"
2782 echo -ne "\007"
2783 }
2784
2785 # note, this wont work:
2786 # x=$(mktemp); cp a $x
2787 # I havnt figured out why, bigger fish to fry.
2788 #
2789 # for titlebar.
2790 # condition from the screen man page i think.
2791 # note: duplicated in tx()
2792 if [[ $TERM == *(screen*|xterm*|rxvt*) ]]; then
2793 trap 'settitle "$BASH_COMMAND"' DEBUG
2794 else
2795 trap DEBUG
2796 fi
2797
2798 fi
2799
2800 # * stuff that makes sense to be at the end
2801
2802
2803 # best practice
2804 unset IFS
2805
2806 # shellcheck disable=SC1090
2807 [[ -s "$HOME/.rvm/scripts/rvm" ]] && source "$HOME/.rvm/scripts/rvm" # Load RVM into a shell session *as a function*
2808
2809 # I had this idea to start a bash shell which would run an initial
2810 # command passed through this env variable, then continue on
2811 # interactively. But the use case I had in mind went away.
2812 #
2813 # if [[ $MY_INIT_CMD ]]; then
2814 # "${MY_INIT_CMD[@]}"
2815 # unset MY_INIT_CMD
2816 # fi
2817
2818 # ensure no bad programs appending to this file will have an affect
2819 return 0